IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc
	.686
.xmm
    get_cpu_id_string PROTO :DWORD

    rcnt equ <16>
    padd equ <db 0>

    correctness equ <0>     ; set to 1 for display of correctness testing.
    icnt equ <10000000>     ; iteration count for benchmark

    alex1 equ <1>
    alex2 equ <0>
    clive equ <1>
    lingo equ <1>

    lingo_htodw PROTO :DWORD
    Alex_Short PROTO :DWORD
    Alex_Long PROTO :DWORD
    clive_htodw PROTO :DWORD

	.data
align 16
mask39h dq 3939393939393939h
maskFFh dq 00FF00FF00FF00FFh
;maskD0h dq 0D0D0D0D0D0D0D0D0h
;maskF9h dq 0F9F9F9F9F9F9F9F9h
;mask0Fh dq 0F0F0F0F0F0F0F0Fh
;mask30h dq 3030303030303030h

    .code
start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL buffer[260]:BYTE
    LOCAL pbuf  :DWORD

    mov pbuf, ptr$(buffer)

 ;     invoke get_cpu_id_string,pbuf       ; get the processor string
 ;     mov pbuf, rv(szMonoSpace,pbuf)      ; format it
 ;     print pbuf,13,10                    ; display formatted string

    IF correctness

    print "-------------------",13,10
    print "Correctness testing",13,10
    print "-------------------",13,10,13,10

  ; -----------------------------

    print "htodw Library",13,10

    fn htodw,"CD2FAD33"
    print hex$(eax),13,10

    fn htodw,"3"
    print hex$(eax),13,10

    fn htodw,"C0000"
    print hex$(eax),13,10,13,10

  ; -----------------------------

    IF alex1

    print "Alex_Short",13,10

    fn Alex_Short,"CD2FAD33"
    print hex$(eax),13,10

    fn Alex_Short,"3"
    print hex$(eax),13,10

    fn Alex_Short,"C0000"
    print hex$(eax),13,10,13,10

    ENDIF

  ; -----------------------------

    IF lingo

    print "Lingo",13,10

    fn lingo_htodw,"CD2FAD33"
    print hex$(eax),13,10

    fn lingo_htodw,"3"
    print hex$(eax),13,10

    fn lingo_htodw,"C0000"
    print hex$(eax),13,10,13,10

    ENDIF

  ; -----------------------------

    IF alex2

    print "Alex Unrolled",13,10

    fn Alex_Long,"CD2FAD33"
    print hex$(eax),13,10

    fn Alex_Long,"3"
    print hex$(eax),13,10

    fn Alex_Long,"C0000"
    print hex$(eax),13,10,13,10

    ENDIF

  ; -----------------------------

    IF clive

    print "clive_htodw",13,10

    fn clive_htodw,"CD2FAD33"
    print hex$(eax),13,10

    fn clive_htodw,"3"
    print hex$(eax),13,10

    fn clive_htodw,"C0000"
    print hex$(eax),13,10

    print chr$(13,10),"-------",13,10
    print "Timings",13,10
    print "-------",13,10,13,10

    ENDIF

 ;     ELSE
 ;       fn htodw,"CD2FAD33"
 ;       fn Alex_Short,"CD2FAD33"
 ;       fn lingo_htodw,"CD2FAD33"
 ;       fn Alex_Long,"CD2FAD33"
 ;       fn clive_htodw,"CD2FAD

    ENDIF

    push ebx
    push esi
    push edi

    invoke SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS

  ; ==============================

    invoke SleepEx, 500, 0
    rdtsc

    invoke GetTickCount
    push eax

    mov esi, icnt

  @@:
    fn htodw,"C0000000"
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," atodw library",13,10

  ; ==============================

    IF alex1

    invoke SleepEx, 500, 0
    rdtsc

    invoke GetTickCount
    push eax

    mov esi, icnt

  @@:
    fn Alex_Short,"C0000000"
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," Alex short",13,10

    ENDIF

  ; ==============================

    IF alex2

    invoke SleepEx, 500, 0
    rdtsc

    invoke GetTickCount
    push eax

    mov esi, icnt

  @@:
    fn Alex_Long,"C0000000"
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," Alex long",13,10

    ENDIF

  ; ==============================

    IF lingo

    invoke SleepEx, 500, 0
    rdtsc

    invoke GetTickCount
    push eax

    mov esi, icnt

  @@:
    fn lingo_htodw,"C0000000"
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," Lingo long",13,10

    ENDIF

  ; ==============================

    IF clive

    invoke SleepEx, 500, 0
    rdtsc

    invoke GetTickCount
    push eax

    mov esi, icnt

  @@:
    fn clive_htodw,"C0000000"
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," clive short",13,10

    ENDIF

  ; ==============================

    invoke SleepEx, 500, 0
    rdtsc

    invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

 ; get_cpu_id_string proc pBuffer:DWORD
 ; 
 ;     LOCAL basicinf  :DWORD
 ;     LOCAL extended  :DWORD
 ; 
 ;     mov eax, 0                                  ; call basic info function
 ;     cpuid
 ;     mov basicinf, eax
 ; 
 ;     mov eax, 80000000h                          ; call extended info function
 ;     cpuid
 ;     mov extended, eax
 ; 
 ;     .if extended == 80000004h || extended == 80000008h
 ;       jmp getID
 ;     .endif
 ; 
 ;     .if basicinf == 00000001h
 ;       cst pBuffer, "i486 or early Pentium Processor"
 ;       ret
 ;     .elseif basicinf == 00000002h
 ;       cst pBuffer, "Pentium Pro, II or Celeron Processor"
 ;       ret
 ;     .elseif basicinf == 00000003h
 ;       cst pBuffer, "Pentium III Processor"
 ;       ret
 ;     .else
 ;       cst pBuffer, "Cannot Identify x86 Processor"
 ;       ret
 ;     .endif
 ; 
 ;   getID:
 ; 
 ;     push ebx
 ;     push esi
 ; 
 ;     mov esi, pBuffer                    ; load buffer address into ESI
 ;    
 ;     mov eax, 80000002h                  ; extended function 2
 ;     cpuid
 ; 
 ;     mov [esi],    eax                   ; write results to buffer
 ;     mov [esi+4],  ebx
 ;     mov [esi+8],  ecx
 ;     mov [esi+12], edx
 ; 
 ;     mov eax, 80000003h                  ; extended function 3
 ;     cpuid
 ; 
 ;     mov [esi+16], eax                   ; write results to buffer
 ;     mov [esi+20], ebx
 ;     mov [esi+24], ecx
 ;     mov [esi+28], edx
 ; 
 ;     mov eax, 80000004h                  ; extended function 4
 ;     cpuid
 ; 
 ;     mov [esi+32], eax                   ; write results to buffer
 ;     mov [esi+36], ebx
 ;     mov [esi+40], ecx
 ;     mov [esi+44], edx
 ; 
 ;     mov [esi+48], DWORD PTR 0           ; terminate result
 ; 
 ;     pop esi
 ;     pop ebx
 ; 
 ;     ret
 ; 
 ; get_cpu_id_string endp

; 

IF lingo

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
lingo_htodw proc lpString:DWORD
  ; -------------------------------
  ; Lingo long version (decyphered)
  ; -------------------------------
    mov edx, [esp+4]
    push ebx
    mov ebx, [edx]
    xor ecx, ecx 	
    add cl, bl
    jz End1
    mov eax, [l_tbl_8+ecx*4-192] 
    xor ecx, ecx 	
    add cl, bh
    jz End2
    mov edx, [edx+4]
    add eax, [l_tbl_7+ecx*4-192] 
    xor ecx, ecx 	
    shr ebx, 16
    add cl, bl
    jz End3
    add eax, [l_tbl_6+ecx*4-192] 
    xor ecx, ecx 	
    add cl, bh
    jz End4
    add eax, [l_tbl_5+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dl
    jz End5
    add eax, [l_tbl_4+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dh
    jz End6
    add eax, [l_tbl_3+ecx*4-192] 
    pop ebx 
    shr edx, 16
    xor ecx, ecx 	
    add cl, dl
    jz End7
    add eax, [l_tbl_2+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dh
    jz End8
    add eax, [l_tbl_1+ecx*4-192] 
    ret 4

    align 16
  End1:
    pop ebx
    ret  4
  align 16
    l_tbl_8 dd 0,10000000h,20000000h,30000000h,40000000h,50000000h,60000000h,70000000h,80000000h,90000000h
          dd 0,0,0,0,0,0,0,0A0000000h,0B0000000h,0C0000000h,0D0000000h,0E0000000h,0F0000000h
          dd 26 Dup(0),0A0000000h,0B0000000h,0C0000000h,0D0000000h,0E0000000h,0F0000000h
    align 16
  End2:
    shr eax, 28
    pop ebx
    ret 4
 align 16
    l_tbl_7 dd 0,1000000h,2000000h,3000000h,4000000h,5000000h,6000000h,7000000h,8000000h,9000000h
          dd 0,0,0,0,0,0,0,0A000000h,0B000000h,0C000000h,0D000000h,0E000000h,0F000000h
          dd 26 Dup(0),0A000000h,0B000000h,0C000000h,0D000000h,0E000000h,0F000000h
  align 16
  End3:
    shr eax, 24
    pop ebx
    ret 4
  align 16
    l_tbl_6 dd 0,100000h,200000h,300000h,400000h,500000h,600000h,700000h,800000h,900000h
          dd 0,0,0,0,0,0,0,0A00000h,0B00000h,0C00000h,0D00000h,0E00000h,0F00000h
          dd 26 Dup(0),0A00000h, 0B00000h,0C00000h,0D00000h,0E00000h,0F00000h
    align 16
  End4:
    shr eax, 20
    pop ebx
    ret 4
  align 16
    l_tbl_5 dd 0,10000h,20000h,30000h,40000h,50000h,60000h,70000h,80000h,90000h
          dd 0,0,0,0,0,0,0,0A0000h,0B0000h,0C0000h,0D0000h,0E0000h,0F0000h
          dd 26 Dup(0),0A0000h, 0B0000h,0C0000h,0D0000h,0E0000h,0F0000h
    align 16
  End5:
    shr eax, 16
    pop ebx
    ret 4
  align 16
    l_tbl_4 dd 0,1000h,2000h,3000h,4000h,5000h,6000h,7000h,8000h,9000h
          dd 0,0,0,0,0,0,0,0A000h,0B000h,0C000h,0D000h,0E000h,0F000h
          dd 26 Dup(0),0A000h,0B000h,0C000h,0D000h,0E000h,0F000h
    align 16
  End6:
    shr eax, 12
    pop ebx
    ret 4
	align 16
    l_tbl_3 dd 0,100h,200h,300h,400h,500h,600h,700h,800h,900h
          dd 0,0,0,0,0,0,0,0A00h,0B00h,0C00h,0D00h,0E00h,0F00h
          dd 26 Dup(0),0A00h,0B00h,0C00h,0D00h,0E00h,0F00h
  End7:
    shr eax, 8
    ret 4
	align 16
    l_tbl_2 dd 0,10h,20h,30h,40h,50h,60h,70h,80h,90h
          dd 0,0,0,0,0,0,0,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h
          dd 26 Dup(0),0A0h,0B0h,0C0h,0D0h,0E0h,0F0h
    align 16
  End8:
    shr eax, 4
    ret 4
	align 16
    l_tbl_1 dd 0,1h,2h,3h,4h,5h,6h,7h,8h,9h
          dd 0,0,0,0,0,0,0,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
          dd 26 Dup(0),0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
lingo_htodw  endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ENDIF

; 

IF alex1

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

Alex_Short proc lpszStr:DWORD

    mov edx, [esp+4]
    mov eax, 0
    mov [esp+4], edi
    movzx edi, BYTE PTR [edx]
    movzx ecx, BYTE PTR [edx]
    test ecx, ecx
    jz lbl1

  lbl0:
    and edi, 15
    shr ecx, 6
    add edx, 1
    shl eax, 4
    lea edi, [edi+ecx*8]
    add eax, ecx
    add eax, edi
    movzx ecx, BYTE PTR [edx]
    movzx edi, BYTE PTR [edx]
    test ecx, ecx
    jnz lbl0

  lbl1:
    mov edi, [esp+4]
    ret 4

Alex_Short    endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ENDIF

; 

IF clive

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

clive_htodw proc lpString:dword

        pop     eax
        pop     edx
        movzx   ecx, byte ptr [edx]
        push    eax
        xor     eax, eax
        push    ebx
        test    ecx, ecx
        je      @2

      @1:
        add     edx, 1
        or      ecx, 020h
        shl     eax, 4
        add     ecx, -060h
        lea     ebx, [ecx+027h]
        cmovb   ebx, ecx
        movzx   ecx, byte ptr [edx]
        lea     eax, [eax+ebx+9]
        test    ecx, ecx
        jnz     @1

      @2:
        pop     ebx

        ret

clive_htodw endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ENDIF

; 

IF alex2

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
Alex_Long proc lpszStr:DWORD

    mov edx,[esp+4]

    @l1:
    movzx ecx,byte ptr [edx]
    test ecx, ecx
    jz @done
    mov eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+1]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+2]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+3]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+4]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+5]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+6]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+7]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    ret 4

  @done:
    shr eax,4
    ret 4

    align 16
  @@table:
    dd 0,1,2,3,4,5,6,7,8,9
    dd 7 dup (-1)
    dd 10,11,12,13,14,15
    dd 26 dup(-1)
    dd 10,11,12,13,14,15
		
Alex_Long endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ENDIF

; 

REPEAT rcnt
  padd
ENDM

align 16        ; runs library htodw at correct speed.

end start
